<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="$t('自编号')" prop="selfNo">
        <el-input v-model="queryParams.selfNo" :placeholder="$t('请输入自编号')" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item :label="$t('柜号')" prop="cubNo">
        <el-input v-model="queryParams.cubNo" :placeholder="$t('请输入柜号')" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>

      <el-form-item :label="$t('始发地')" prop="startWarehouseId">
        <el-select v-model="queryParams.startWarehouseId" :placeholder="$t('请选择始发地')">
          <el-option v-for="item in exportWarehouseList" :label="item.titleZh" :value="item.id" :key="item.id"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item :label="$t('目的地')" prop="destWarehouseId">
        <el-select v-model="queryParams.destWarehouseId" :placeholder="$t('请选择目的地')">
          <el-option v-for="item in importWarehouseList" :label="item.titleZh" :value="item.id" :key="item.id"></el-option>
        </el-select>
      </el-form-item>

      <el-form-item :label="$t('状态')" prop="boxStatus">
        <el-select v-model="queryParams.boxStatus" :placeholder="$t('请选择状态')" clearable size="small">
          <el-option v-for="dict in this.getDictDatas(DICT_TYPE.BOX_SHIPMENT_STATUS)" :key="dict.value" :label="$l(dict, 'label')" :value="dict.value" />
        </el-select>
      </el-form-item>

      <el-form-item label="" prop="date">
        <el-select v-model="queryParams.dateType" :placeholder="$t('请选择时间类型')" clearable size="small">
          <el-option v-for="item in dateTypes" :key="item.value" :label="item.label" :value="item.value" />
        </el-select>
      </el-form-item>

      <el-form-item label="">
        <el-date-picker v-model="queryParams.dateRangeCreateTime" style="width: 240px" value-format="yyyy-MM-dd HH:mm:ss" type="datetimerange" range-separator="-" start-:placeholder="$t('开始日期')" end-:placeholder="$t('结束日期')" />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">{{ $t('搜索') }}</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">{{ $t('重置') }}</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd" v-hasPermi="['shipment:box:create:air']">{{ $t('出货安排') }} </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading" v-hasPermi="['shipment:box:export:air']">{{ $t('导出') }} </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column :label="$t('自编号')" align="center" prop="selfNo" />
      <el-table-column :label="$t('运输方式')" align="center" prop="transportType">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.ECW_TRANSPORT_TYPE" :value="scope.row.transportType" />
        </template>
      </el-table-column>

      <el-table-column :label="$t('出货渠道')" align="center" prop="shippingChannelId">
        <template slot-scope="scope">
          <span>{{ getShipChannelName(scope.row.shippingChannelId) }}</span>
        </template>
      </el-table-column>

      <el-table-column label="方数（预装/已装）" align="center" prop="squareNumber" />
      <el-table-column label="重量（预装/已装）" align="center" prop="weight" />

      <el-table-column :label="$t('状态')" align="center" prop="boxStatus">
        <template slot-scope="scope">
          <dict-tag :type="DICT_TYPE.BOX_SHIPMENT_STATUS" :value="scope.row.boxStatus" />
        </template>
      </el-table-column>

      <el-table-column :label="$t('日期')" align="center" prop="createTime" width="180">
        <template slot-scope="scope">
          <span>{{ new Date(scope.row.createTime).format('yyyy-MM-dd hh:mm:ss') }}</span>
        </template>
      </el-table-column>
      <el-table-column :label="$t('操作')" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <!-- <el-button size="mini" type="text" icon="el-icon-view" @click="handleView(scope.row)"
                     v-hasPermi="['shipment:box:query']">{{$t('查看')}}</el-button>
          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['shipment:box:update']">{{$t('修改')}}</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['shipment:box:delete']">{{$t('删除')}}</el-button> -->
          <el-dropdown trigger="click" @command="(command) => handleCommand(scope.row, command)">
            <el-button type="primary"> {{ $t('操作') }}<i class="el-icon-arrow-down el-icon--right"></i> </el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="edit">{{$t('编辑')}}</el-dropdown-item>
              <el-dropdown-item command="air">{{$t('操作')}}-{{$t('空运')}}</el-dropdown-item>
              <el-dropdown-item command="error">{{$t('异常登记')}}</el-dropdown-item>
              <el-dropdown-item command="cost">{{$t('费用登记')}}</el-dropdown-item>
              <el-dropdown-item command="batchMarkup">{{$t('批量加价')}}</el-dropdown-item>
              <el-dropdown-item command="delete">{{$t('删除')}}</el-dropdown-item>

            </el-dropdown-menu>
          </el-dropdown>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize" @pagination="getList" />

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="dialogCfg.title" :visible.sync="dialogCfg.open" :width="dialogCfg.width" :fullscreen="dialogCfg.fullscreen" append-to-body class="shippingSea-dialog">
      <template v-if="dialogCfg.dialogType === 'edit' || dialogCfg.dialogType === 'add'">
        <editAirForm v-if="dialogCfg.open" @closeDialog="closeDialog" :shipmentObj="currRow" :warehouseList="warehouseList" :transportTypes="transportTypes" />
      </template>
      <template v-if="dialogCfg.dialogType === 'cost'">
        <costForm v-if="dialogCfg.open" @closeDialog="closeDialog" :shipmentObj="currRow" />
      </template>
      <template v-if="dialogCfg.dialogType === 'error'">
        <regError v-if="dialogCfg.open" @closeDialog="closeDialog" :shipmentObj="currRow" :allUsers="allUsers" />
      </template>
      <template v-if="dialogCfg.dialogType === 'editLadingBill'">
        <ladingBill v-if="dialogCfg.open" @closeDialog="closeDialog" :shipmentObj="currRow" :getCabinetName="getCabinetName" />
      </template>
      <template v-if="dialogCfg.dialogType === 'notice'">
        <div class="notice-dialog">
          <div class="notice-title">
            {{
              $t('您有{cnt}个待处理出货操作，请尽快前往处理', {
                cnt: noticeList.length
              })
            }}：
          </div>
          <el-table :data="noticeList" height="500px" border>
            <el-table-column :label="$t('自编号')" align="center" prop="selfNo" />
            <el-table-column :label="$t('类型')" align="center">
              <template slot-scope="scope">
                <dict-tag :type="DICT_TYPE.BOX_SHIPPING_NOTICE_TYPE" :value="String(scope.row.noticeType)" />
              </template>
            </el-table-column>
            <el-table-column :label="$t('预计时间')" align="center">
              <template slot-scope="scope">
                {{ formatDate(scope.row.createTime) }}
              </template>
            </el-table-column>
            <el-table-column :label="$t('操作')" align="center" width="80">
              <template slot-scope="scope">
                <el-button type="text" @click="handleCommand(scope.row, 'handle')">{{ $t('处理') }}</el-button>
              </template>
            </el-table-column>
          </el-table>
          <el-row class="operate-button">
            <el-button type="primary" @click="closeDialog">{{ $t('关闭窗口') }}</el-button>
          </el-row>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script>
import { createbox, updatebox, deletebox, getbox, getboxPage, exportboxExcel } from '@/api/ecw/box'
import { getChannelList } from '@/api/ecw/channel'
import { getWarehouseList } from '@/api/ecw/warehouse'
import costForm from './costForm.vue'
import regError from './regError.vue'
import editAirForm from './editAirForm.vue'

export default {
  name: 'indexAir',
  components: {
    costForm,
    regError,
    editAirForm
  },
  data() {
    return {
      dateTypes: [
        { value: '1', label: this.$t('分拣时间') },
        { value: '2', label: this.$t('装柜时间') },
        { value: '3', label: this.$t('起运时间') },
        { value: '4', label: this.$t('到港时间') },
        { value: '5', label: this.$t('清关时间') },
        { value: '6', label: this.$t('提货时间') }
      ],

      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 出货列表
      list: [],
      // 弹出层标题
      title: '',
      // 是否显示弹出层
      // 弹出类型
      dialogCfg: {
        title: '',
        dialogType: '',
        width: '600px',
        // 是否显示弹出层
        open: false,
        fullscreen: false
      },
      dateRangeCreateTime: [],
      transportTypes: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        id: null,
        selfNo: null,
        cubNo: null,
        cabinetId: null,
        boxStatus: null,
        startWarehouseId: null,
        destWarehouseId: null,
        transportType: null
      },
      channelList: [],
      warehouseList: [],
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        shippingChannelId: [
          {
            required: true,
            message: this.$t('出货渠道不能为空'),
            trigger: 'blur'
          }
        ],
        startWarehouseId: [
          {
            required: true,
            message: this.$t('始发地不能为空'),
            trigger: 'blur'
          }
        ],
        destWarehouseId: [
          {
            required: true,
            message: this.$t('目的地不能为空'),
            trigger: 'blur'
          }
        ]
      }
    }
  },
  computed: {
    exportWarehouseList() {
      return this.warehouseList.filter((item) => item.tradeType == '2' || item.type == '3')
    },
    importWarehouseList() {
      return this.warehouseList.filter((item) => item.tradeType == '1' || item.type == '3')
    },

    getShipChannelName() {
      return (shippingChannelId) => {
        for (let index in this.channelList) {
          let channelItem = this.channelList[index]
          if (channelItem.channelId == shippingChannelId) {
            return this.$l(channelItem, 'name')
          }
        }
        return '/'
      }
    }
  },
  created() {
    this.transportTypes = this.getDictDatas(
      this.DICT_TYPE.ECW_TRANSPORT_TYPE
    ).filter((item) => item.value == "3");console.log(this.getDictDatas(
      this.DICT_TYPE.ECW_TRANSPORT_TYPE
    ),'this.transportTypes')
    getWarehouseList().then((res) => (this.warehouseList = res.data))
    this.getList()
    this.getChannelList()
  },
  methods: {
    getChannelList() {
      getChannelList().then((res) => (this.channelList = res.data))
    },

    /** 查询列表 */
    getList() {
      this.loading = true
      // 处理查询参数
      let params = { ...this.queryParams }
      params.transportType = 3
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime')
      // 执行查询
      getboxPage(params).then((response) => {
        this.list = response.data.list
        this.total = response.data.total
        this.loading = false
      })
    },
    /** 取消按钮 */
    cancel() {
      this.open = false
      this.reset()
    },
    /* 关闭弹窗 */
    closeDialog(type) {
      this.$set(this.dialogCfg, "open", false);
      if (type === "add" || type === "edit") {
        this.getList();
      }
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        cabinetId: undefined,
        startWarehouseId: undefined,
        destWarehouseId: undefined,
        transportType: undefined
      }
      this.resetForm('form')
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = []
      this.resetForm('queryForm')
      this.handleQuery()
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$set(this.dialogCfg, 'title', this.$t('添加出货'))
      this.$set(this.dialogCfg, 'dialogType', 'add')
      this.$set(this.dialogCfg, 'width', '600px')
      this.$set(this.dialogCfg, 'fullscreen', false)
      this.$set(this.dialogCfg, 'open', true)
      this.currRow = {
        transportType: '3'
      }
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      const id = row.id;
      getbox(id).then((response) => {
        this.currRow = response.data;
        this.$set(this.dialogCfg, "title", this.$t("修改出货"));
        this.$set(this.dialogCfg, "dialogType", "edit");
        this.$set(this.dialogCfg, "width", "600px");
        this.$set(this.dialogCfg, "open", true);
      });
    },

    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id
      this.$modal
        .confirm(this.$t('是否确认删除出货编号为{id}的数据项?', { id }))
        .then(function () {
          return deletebox(id)
        })
        .then(() => {
          this.getList()
          this.$modal.msgSuccess(this.$t('删除成功'))
        })
        .catch(() => {})
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = { ...this.queryParams } 
      params.pageNo = undefined
      params.pageSize = undefined
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime')
      // 执行导出
      this.$modal
        .confirm(this.$t('是否确认导出所有出货数据项?'))
        .then(() => {
          this.exportLoading = true
          return exportboxExcel(params)
        })
        .then((response) => {
          this.$download.excel(response, '${table.classComment}.xls')
          this.exportLoading = false
        })
        .catch(() => {})
    },
    /** 查看按钮操作 */
    handleCommand(row, command) {
      switch (command) {
        case 'air':
          this.$router.push('/boxAir/shippingAir/' + row.id)
          break

        case 'edit':
          this.handleUpdate(row)
          break

          case 'delete':
            this.handleDelete(row);
            break;
          case 'batchMarkup':
            this.$router.push('batch_markup?shipmentId=' + row.id)
        }
      },
    }
  }

</script>

<style lang="scss" scoped>
.notice-dialog {
  ::v-deep .notice-title {
    font-size: 24px;
    font-weight: bold;
    margin-bottom: 10px;
  }
  ::v-deep .operate-button {
    margin-top: 10px;
    text-align: center;
  }
}
</style>

